

; ************************************************************
;
;			 	      counter.asm
;
;			 Test programm for AVRee - development board
;
;				  	  binary counter PORT B & D
;					    
; ************************************************************

; Include definition of registers (change to correct processor type 
; and software installation on your PC!)
; i.e.: .include "C:\Program Files\AVR Studio\AVRAssembler\Appnotes\2313def.inc"
; if 2313def.inc does not reside in the same directory as this .ASM file

.include "2313def.inc"

; Define register names
; NOTE: "Immediate"-instructions only apply to r16 - r31 !

.def	temp	= r16		      ; temp. storage
.def	b		= r17		; Register for output to Port B
.def	d		= r18		; Register for output to Port D
.def	status	= r0		; STATUS register


; *** Interrupt table ***

			rjmp	RESET		

				

; *** Start program ***
RESET:
init:		ser	temp		; temp <- 0xFF (temp = 1111 1111)
		out	DDRB,temp	; Port B -> All pins output
	      out   DDRD,temp	; Port D -> All pins output
		clr b
		clr d
		rjmp main

;-----------Main ---------------------

main:	   	inc b				;increment b 
		out PORTB,b			;b to PortB 
  		tst	b			;
	   	breq incportd		;if b = 0x00 -> increment PortD 
	  	rjmp main			;
	      	
incportd:	inc d				;increment d  
		out PORTD,d			;d to Port D 
		rjmp main			;back to main

